## libmprivacy 1.0.57+aatgv4

=== Makefile ===
CFLAGS+=-g -c -std=gnu99 -Wall -Werror -O2 -fPIC -mtune=generic -flto
LDFLAGS+=-static
#ifdef WIN32
WINDRES=$(TARGET)-windres
STRIP=$(TARGET)-strip
AR=$(TARGET)-ar
CFLAGS+= -Wl,--subsystem,windows
LDFLAGS+= -mwindows -lpsapi -liconv -lpcre2-8 -lws2_32
#else
STRIP=strip
AR=ar
#endif /* #ifdef WIN32 */
SOURCES=winscp_connector.c winscp_ini_handler.c tgpro_environment.c mp_utils.c win_registry_utils.c mp_simple_list.c log.c
OBJECTS=$(SOURCES:.c=.o)
HEADERS=$(SOURCES:.c=.h) activedirectory-dev.h mime.h log.h
LIBFILE=libmprivacy.a

all: $(SOURCES) $(LIBFILE)

$(LIBFILE): $(OBJECTS)
	$(AR) -cvq $@ $(OBJECTS)
#	$(STRIP) $@

%.o: %.c
	$(CC) $(CFLAGS) $< -o $@

clean:
	rm -rf *.o $(LIBFILE)

install: $(LIBFILE)
	mkdir --parents $(DESTDIR)/usr/$(TARGET)/lib/
	cp -v $(LIBFILE) $(DESTDIR)/usr/$(TARGET)/lib/
	mkdir --parents $(DESTDIR)/usr/$(TARGET)/include/
	cp -v $(HEADERS) $(DESTDIR)/usr/$(TARGET)/include/

=== debian/changelog ===
libmprivacy (1.0.57+aatgv4) unstable; urgency=low

  * git d27e23c6b7ef590663c4552f3e53225e7144b4ea
    tgpro_environment.c: use very old unused code.
  * git cf641665d16436db3a78fec42cfee3556440918a
    tgpro_environment:
    get_url_whitelist_path_startpath,
    get_url_whitelist_path_viewer_config_dir,
    get_url_whitelist_path_user and
    get_url_whitelist_path_system
    all return a char* instead of a const char*, which was
    actually a masked allocated char*. Like this, the caller will
    be responsible for freeing them.
    Much better memory allocation too: handle possible issues while
    allocating memory.
    Also use a new construct_path helper function to make it more
    readable.
    I know, I'm breaking the API. Sorry if I caused you trouble!
  * git 198af351b856fb29e92ce018915536b5aeac7519
    tgpro_environment.c: Refactor whitelist path functions to reduce redundancy
    Introduce helper function `try_get_whitelist_path` to handle common
    logic for checking the existence of the primary and fallback
    whitelist files. Allowing to remove quite a bit of redundant code.
  * git b478721830f599ba7f7d57907fdd3bc5a004650b
    tgpro_environment: make get_url_whitelist_path_user linux-compatible
    (use $HOME as "appdata").

 -- Juan Garcia <jua@m-privacy.de>  Tue, 17 Dec 2024 13:09:00 +0100

libmprivacy (1.0.57+aaxmp3) unstable; urgency=low

  * git 7c91feefa79fd8ceace885fec4a52e0fe38f5627
    BUG 0006965: tg-Gruppe für mail (Thunderbird) - tgmailicon
    activedirectory-dev.h: add tgmailicon to regex and to list of
    tg group CN's.

 -- Juan Garcia <jua@m-privacy.de>  Fri, 01 Oct 2024 14:27:00 +0100

libmprivacy (1.0.57+aaxmp2) unstable; urgency=low

  * git 3f35a51c60b2d8fb19ec0467a1886d5dadeeb429
    tgpro_environment: expose the following funtions:
    const char* get_url_whitelist_path_system();
    const char* get_url_whitelist_path_user();
    const char* get_url_whitelist_path_startpath();
    const char* get_url_whitelist_path_viewer_config_dir(const char* viewer_config_dir);
  * git bdf6cca979b39647470ddc6b3246a68583b9e9d9
    activedirectory-dev.h: add missing #include <ctype.h>

 -- Amon Ott <ao@m-privacy.de>  Wed, 25 Sep 2024 09:36:00 +0200

libmprivacy (1.0.57+aaxmp1) unstable; urgency=low

  * Rebuild with GCC 14

 -- Amon Ott <ao@m-privacy.de>  Wed, 28 Aug 2024 10:26:00 +0200

libmprivacy (1.0.57+aavmp18) unstable; urgency=low

  * git 6dc10f154d22971aac685fdd790aed7caaa16877
    AD-OpenLPAP: return MP_LDAP_EMPTY_RESPONSE_ERROR from
    get_tg_groups_from_openldap_new if the response was completely empty.
    Correctly interpret the return value too: unset TGGROUPS to
    make sure it's not "empty" for password and certificate users
    (who are not in the LDAP server).
  * git 3ca8d5b67bdc0d2e4fe64a671e768b25032f28d9
    AD-OpenLDAP: Change a generic MP_LDAP_ERROR to MP_LDAP_NO_GROUPS_ERROR
    in get_tg_groups_from_openldap_new. Also log the results if they're
    MP_LDAP_QUERY_EXEC_ERROR and MP_LDAP_NO_GROUPS_ERROR (just for clarity).
  * git 7fbed21d2048604edca55b1461e3ea0f7a0dc677
    AD-OpenLDAP: log if unable to get 'dn' for user in perform_ldap_search.
  * git f4e8f53a3d3ca5734a98f7cdfe45480af9b09040
    activedirectory-dev: print some logs directly as syslog.

 -- Juan Garcia <jua@m-privacy.de>  Thu, 08 Aug 2024 12:42:00 +0200

libmprivacy (1.0.57+aavmp17) unstable; urgency=low

  * git f76fd0c665652d48548992e8bb1e60f96b14047b
    mp_utils.c: check for allocation failure.
  * git 9086085502c7c3d9bb508aa154e2a4916037ece8
    BUG 0006876: Viewer - autotransfer (ggf auch OPSWAT etc) Fehler mit zu langen Namen (oder Umlauten)
    mp_utils.c: use CP_ACP (system default Windows ANSI code page)
    in utf8_char_to_wchar_t() to transform to wchar_t (which works
    better than UTF8 because Windows is veery special).
    Like this _wrename (in mp_move) works correctly for filenames
    with non-ASCII characters.
    Of course, this could actually break stuff too that used to work.
    We'll see.
  * git 7bbd7d92ae40923229ec4be6c419125bb1381554
    BUG 0006776: libmprivacy: Rückgabe Typ von get_user_name zu const char* ändern
    tgpro_environment: change return get_user_name's type to const char*
    to avoid use-after-free situations (the compiler already complains
    like this).
  * git 2d968dda3bd04715ffcc621bf56ae700ad0b84e1
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    BUG 0006901: Schleuse: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    Add int create_send_to_shortcut(const char* config_dir, const char* description)
    function that creates an lnk file in shell:sendto for the current
    user. We still need to call this function.
  * git 757d49abdeaca443b40f8c3b343f6d6660ad31da
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    BUG 0006901: Schleuse: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    tgpro_environment: check whether config_dir is an empty string
    after checking it's not null.
  * git cefb10b09af268eff769abb00b813d9a9c04a517
    BUG 0006900: Viewer: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    BUG 0006901: Schleuse: Send-To-TG-Pro-Verknüpfung beim Start erstellen (inkl. configdir-Option)
    tgpro_environment.c: add get_absolute_path function and use it
    to calculate config_dir's absolute path while creating a send-to
    shortcut.
  * git 692203d9814ba4ce2ea660366db496cb414a4c79
    BUG 0006958: AD: Weder VNC- noch SSH-Server können die TG-Gruppen der "Domänen Benutzer" auslesen
    activedirectory-dev: use correct filter to search for the primary
    group's dn (bug introduced in aeae52e5).

 -- Juan Garcia <jua@m-privacy.de>  Tue, 09 Jul 2024 12:57:00 +0200

libmprivacy (1.0.57+aavmp16) unstable; urgency=low

  * git 9069f695b2297c53b1e3aec6c5b0cfa4bb9e857b


=== debian/control ===
Source: libmprivacy
Section: devel
Priority: optional
Build-Depends: debhelper (>= 4.0), libpcre2-dev
Maintainer: Juan Garcia
Standards-Version: 3.7.2.2

Package: libmprivacy
Architecture: any
Depends: ${shlibs:Depends}
Description: Helper functions for m-privacy client tools.

=== debian/rules ===
#!/usr/bin/make -f
#
# debian/rules file to build a Mingw32 cross compiler toolchain.
#
# Created 30 Jan 2001, by Ron Lee <ron@debian.org>

#export DH_VERBOSE=1

# m-privacy
export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects

#export CC=gcc-11

package = libmprivacy

DEBVERS := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p')
VERSION := $(shell dpkg-parsechangelog | sed -n -e 's/^Version: //p' | tr '.-' ',,')

top_dir      := $(shell pwd)

DEB_HOST_MULTIARCH =
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

build : build-stamp

configure-stamp:
	touch $@

build-stamp : configure-stamp
	dh_testdir
	$(MAKE) -j9
	touch $@

install : install-stamp

install-stamp : build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k

	$(MAKE) install DESTDIR=$(top_dir)/debian/$(package)/
	touch $@

clean:
	$(MAKE) clean
	dh_testdir
	dh_testroot
	rm -rf *-stamp
	dh_clean


binary-indep:
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installchangelogs
#	dh_strip
	dh_compress
	dh_fixperms
	dh_install
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb -- -Zxz

binary: binary-indep binary-arch

.PHONY: binary-indep binary-arch binary clean build install

## libmprivacy 1.0.58+aatgv3

=== Makefile ===
--- 
+++ 
@@ -10,7 +10,7 @@
 STRIP=strip
 AR=ar
 #endif /* #ifdef WIN32 */
-SOURCES=winscp_connector.c winscp_ini_handler.c tgpro_environment.c mp_utils.c win_registry_utils.c mp_simple_list.c log.c
+SOURCES=winscp_connector.c winscp_ini_handler.c tgpro_environment.c mp_utils.c win_registry_utils.c mp_simple_list.c log.c transfer_log_helpers.c
 OBJECTS=$(SOURCES:.c=.o)
 HEADERS=$(SOURCES:.c=.h) activedirectory-dev.h mime.h log.h
 LIBFILE=libmprivacy.a

=== debian/changelog ===
libmprivacy (1.0.58+aatgv3) unstable; urgency=low

  * git 2f0f86b4d94e26fafd4a8d2e2758ab1c417e7321
    activedirectory-dev: add missing ; at the end of a log line. Also fix small typo in log.
  * git af8982dfd22fb6f177f2eba3ef10dcf8fad97aa3
    activedirectory-dev: Return (new) MP_LDAP_INVALID_ARG if user_domain
    was not passed to generate_ldap_base (and it has to be used).
    This avoids running an strdup(NULL), which was causing the
    ssh segfault in BUG 0006634: Schleuse AD-OpenLDAP geht nicht mehr.
  * git 330b1f01ab1d84715ffade40aa476f3ca2744f32
    Simplify LDAP code: Remove code for ldap_auto='manual' (it was
    dead code anyway as ldap_auto is always being forced to realm by
    the callers).
  * git 63105c766f420bbf12e8104dc64250cb8da79bda
    Simplify LDAP code: ldap_server also being ignored.
  * git 9c545c3c384071e79cc72c32fe3e80b2e08a3822
    Simplify LDAP code: Call perform_ldap_searches() with NULL values
    for ldap_server and ldap_auto.

 -- Juan Garcia <jua@m-privacy.de>  Wed, 08 Oct 2025 14:30:00 +0200

libmprivacy (1.0.58+aazmp2) unstable; urgency=low

  * Add dep: librsbac-dev

  * git 792aa69159bcf04477dbb22b6369842a0a0a201a
    BUG 0007222: Autoschleuse (VNC) protokolliert nicht "Anonym"
    Add transfer_log_helpers (.h and .c).
    Provide helper functions to anonymize or pseudonymize usernames
    and paths before logging file transfers. Includes:
    - resolve_username_for_logs(): returns the resolved username (malloc'ed)
    - replace_username_dir_for_logs(): replaces the username directory in a path (malloc'ed)

 -- Juan Garcia <jua@m-privacy.de>  Thu, 25 Sep 2025 13:23:00 +0200

libmprivacy (1.0.58+aazmp1) unstable; urgency=low

  * Bump version for viewer

 -- Amon Ott <ao@m-privacy.de>  Wed, 10 Sep 2025 10:24:00 +0200

libmprivacy (1.0.57+aazmp1) unstable; urgency=low

  * Rebuild with GCC 15
  * debian/rules:
    - export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection
    - export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection
    - export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection

 -- Amon Ott <ao@m-privacy.de>  Mon, 08 Sep 2025 07:43:00 +0200

libmprivacy (1.0.57+aaxmp9) unstable; urgency=low

  * git 237f74d20eb5965e42df224df086df96686d335e
    activedirectory-dev.h: Add tgsignalicon to possible groups

 -- Juan Garcia <jua@m-privacy.de>  Wed, 13 Aug 2025 15:10:00 +0200

libmprivacy (1.0.57+aaxmp8) unstable; urgency=low

  * git 9f1d19b9061a61160b806705275aa836d3644c51
    BUG 0007213: Umbenennung vom Benutzerkennung im TightGate-Pro
    mp_utils.c: prepareuser_error(): handle new error code 6

 -- Amon Ott <ao@m-privacy.de>  Wed, 16 Jul 2025 15:13:00 +0200

libmprivacy (1.0.57+aaxmp7) unstable; urgency=low

  * git d15e003977145f1e244adb2edaa6c48c4dbb23b4
    get_tgpro_tmp_path(): return long path name instead of legacy
    windows path with '~' if possible.
  * git 22ce4dadd4e3f081dcd6f92816356d71b38efe6f
    get_appdata(): return long path name instead of legacy
    windows path with '~' if possible.
  * git cd28e9d583ee341dc02efe3384c6712619a1ec91
    mp_utils: Add is_valid_utf8 function.
  * git 8ec02b6e63936f99de5c9165dac5acf560bc2879
    mp_utils: Use CP_UTF8 in utf8_char_to_wchar_t by default and
    fall back to CP_ACP if the string isn't a valid UTF8 char*.
  * git 82655ced49f9021652029355d9fb96197cef78e1
    BUG 0007181: URL_Whitelist wird in %appdata%\vnc nicht gefunden
    tgpro_environment: If a URL whitelist file can't be found, continue
    looking for the other ones (and don't just return NULL, as if
    a match couldn't be found).
    y
  * git a88161e91dcbf6b88c025fe1c6a9118729333933
    BUG 0007119: Zert.-Anmeldung an der Schleuse bei Authentisierungsmethode AD wird falsch geloggt
    activedirectory-dev: Log correctly in case we might be reading
    the AD groups from a login that isn't with AD. It could be username
    and password but also certificate: Add 'or a certificate' to log
    to be more precise (or vague enough to make it true :)).
  * git 8b6f5304bbd4cdf31ab939aed6c161078d3845c3
    tgpro_environment: Add linux build error introduced in
    22ce4dadd4e3f081dcd6f92816356d71b38efe6f.

 -- Juan Garcia <jua@m-privacy.de>  Thu, 23 Jun 2025 13:51:00 +0200

libmprivacy (1.0.57+aaxmp6) unstable; urgency=low

  * git 26c7f7de461ea116b104d58b2ac3ffbd42b55809
    tgpro_environment: Add url_encode_non_ascii (mostly to save
    configuration values for WinSCP config files - a.k.a. transfer.ini).
  * git 5a4561fb13281785e2e63e1722096a8542acff57
    BUG 0007176: MagicUrl öffnet HTML-Dateien mit Sonderzeichen (ä z.B.) immer in TG-Pro
    Revert "BUG 0006876: Viewer - autotransfer (ggf auch OPSWAT etc) Fehler mit zu langen Namen (oder Umlauten)"
    This reverts commit 9086085502c7c3d9bb508aa154e2a4916037ece8
    which caused the new #7176 bug. I also think it actually breaks non ASCII
    chars in filenames while autotransfering.

 -- Juan Garcia <jua@m-privacy.de>  Thu, 22 May 2025 10:19:00 +0200

libmprivacy (1.0.57+aaxmp5) unstable; urgency=low

  * git 3fdda04c1fe708744c97828b5a61898dc8743013
    tgpro_environment: Fix Windows build - include pwd.h only #ifndef WIN32.

 -- Amon Ott <ao@m-privacy.de>  Tue, 28 Jan 2025 10:14:00 +0100

libmprivacy (1.0.57+aaxmp4) unstable; urgency=low

  * git d27e23c6b7ef590663c4552f3e53225e7144b4ea
    tgpro_environment.c: use very old unused code.
  * git cf641665d16436db3a78fec42cfee3556440918a
    tgpro_environment:
    get_url_whitelist_path_startpath,
    get_url_whitelist_path_viewer_config_dir,
    get_url_whitelist_path_user and
    get_url_whitelist_path_system
    all return a char* instead of a const char*, which was
    actually a masked allocated char*. Like this, the caller will
    be responsible for freeing them.


=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: libmprivacy
 Section: devel
 Priority: optional
-Build-Depends: debhelper (>= 4.0), libpcre2-dev
+Build-Depends: debhelper (>= 4.0), libpcre2-dev, librsbac-dev
 Maintainer: Juan Garcia
 Standards-Version: 3.7.2.2

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,9 @@
 #export DH_VERBOSE=1
 
 # m-privacy
-export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
-export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
-export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects
+export DEB_CFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection
+export DEB_CXXFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection
+export DEB_LDFLAGS_MAINT_APPEND += -march=x86-64-v2 -mtune=generic -flto=16 -ffat-lto-objects -D_GLIBCXX_ASSERTIONS -fstack-clash-protection
 
 #export CC=gcc-11
